<template>
	<section class="settings_main">
		<div class="p-3 w-100">

			<div class="base_block p-3 mb-3">
				<form class="dash_ftr">
					<div class="d-flex align-items-center py-2 mr-4 position-relative">
						<label style="width: 140px;" class="col-form-label">{{$store.state.locale.beginDate}}:</label>
						<datepicker
								v-model="fromDate"
								:config="options">
						</datepicker>
					</div>

					<div class="d-flex align-items-center py-2 mr-4 position-relative">
						<label style="width: 180px;" class="col-form-label">{{$store.state.locale.endDate}}:</label>
						<datepicker
								v-model="toDate"
								:config="options">
						</datepicker>
					</div>

					<div class="d-flex align-items-center py-2 mr-4 position-relative">
						<div class="custom-control custom-checkbox">
							<input v-model="isFinished" type="checkbox" class="custom-control-input" id="defaultUnchecked">
							<label class="custom-control-label" style="margin-top: 2px;" for="defaultUnchecked">Закрытые аварии</label>
						</div>
					</div>

					<div class="d-flex align-items-center py-2 mr-4">
						<div class="dash_ftr_lbl mr-2">{{ $store.state.locale.city }}:</div>
						<div class="base_select_alt dash_ftr_inp">
							<select class="form-control " v-model="cityIdD">
								<option :value="0">{{ $store.state.locale.all }}</option>
								<option v-for="item in cityListD" :value="item.id">{{ item.name }}</option>
							</select>
							<i class="mdi mdi-menu-down"></i>
						</div>
					</div>
					<div class="d-flex align-items-center py-2 mr-4">
						<div class="dash_ftr_lbl mr-2">{{ $store.state.locale.district }}:</div>
						<div class="base_select_alt dash_ftr_inp">
							<select v-model="districtIdD" class="form-control " :disabled="!cityIdD">
								<option :value="0">{{ $store.state.locale.all }}</option>
								<option v-for="district in districtListD" :value="district.id">
									{{district.name}}
								</option>
							</select>
							<i class="mdi mdi-menu-down"></i>
						</div>
					</div>
					<div class="d-flex align-items-center py-2 mr-4">
						<div class="dash_ftr_lbl mr-2">{{ $store.state.locale.street }}:</div>
						<div class="base_select_alt dash_ftr_inp">
							<select v-model="streetIdD" class="form-control " :disabled="!districtIdD">
								<option :value="0">{{ $store.state.locale.all }}</option>
								<option v-for="street in streetListD" :value="street.id">{{street.name}}</option>
							</select>
							<i class="mdi mdi-menu-down"></i>
						</div>
					</div>
					<div class="d-flex align-items-center py-2 mr-4">
						<div class="dash_ftr_lbl mr-2">{{ $store.state.locale.house }}:</div>
						<div class="base_select_alt dash_ftr_inp">
							<select v-model="houseIdD" class="form-control" :disabled="!streetIdD">
								<option :value="0">{{ $store.state.locale.all }}</option>
								<option v-for="house in houseListD" :value="house.id">{{house.name}}</option>
							</select>
							<i class="mdi mdi-menu-down"></i>
						</div>
					</div>

					<button @click="getAll()" type="button" class="btn call_save_btn dash_ftr_btn">{{ $store.state.locale.filter }}</button>
				</form>
			</div>

			<div class="settings_content_inr base_block">
				<div class="settings_panel p-3">
					<div class="settings_panel_ttl">
						<div class="txt">{{$store.state.locale.accidents}}</div>
						<button type="button" class="login_main_sign_btn bt" data-toggle="modal"
								data-target="#addModal" @click="modeActionType = 1; resetForm()" v-if="can('settings_accident', 'Edit')">
							{{$store.state.locale.addInfo}}
						</button>
					</div>

					<div class="settings_panel_cnt">
						<div class="table-responsive settings_content_tb">
							<table class="table table-striped table-hover">
								<thead>
								<tr>
									<th rowspan="3">#</th>
									<!--<th rowspan="3" colspan="1">Id</th>-->
									<th rowspan="3">{{$store.state.locale.serviceName}}</th>
									<th rowspan="3">{{$store.state.locale.district}}</th>
									<th rowspan="3">{{$store.state.locale.street}}</th>
									<th rowspan="3">{{$store.state.locale.address}}</th>
									<th rowspan="3">{{$store.state.locale.description}}</th>
									<th rowspan="3">{{$store.state.locale.offReason}}</th>
									<th colspan="3">{{$store.state.locale.numObject}}</th>
									<th rowspan="3">{{$store.state.locale.offDate}}</th>
									<th rowspan="1">{{$store.state.locale.timeAndDate}}</th>
									<th rowspan="3">{{$store.state.locale.onDate}}</th>
									<th rowspan="3" v-if="can('settings_accident', 'Edit')"></th>
								</tr>

								<tr>
									<th rowspan="2">{{$store.state.locale.all}}</th>
									<th colspan="2">{{$store.state.locale.livingHouses}}</th>
									<th rowspan="2">{{$store.state.locale.startWork}}</th>
								</tr>

								<tr>
									<th>{{$store.state.locale.own}}</th>
									<th>{{$store.state.locale.sevFloor}}</th>
								</tr>

								</thead>

								<tbody>
								<tr v-for="(item, index) in news">
									<td>{{index+1}}</td>
									<!--<td>{{ item.id }}</td>-->
									<td>{{ orgList.find(x => x.id === item.organizationId) ? orgList.find(x => x.id === item.organizationId).name : '---' }}</td>
									<td>{{ districtList.find(x => x.id === item.regionId) ? districtList.find(x => x.id === item.regionId).name : '---' }}</td>
									<td>{{ getViewStreets(item.streetIds) }}</td>
									<td>{{item.address}}</td>
									<td>{{item.description}}</td>
									<td>{{ newsType.find(x => x.id === item.newsTypeId) ? newsType.find(x => x.id === item.newsTypeId).name : '---' }}</td>
									<td>{{item.affectedPrivateBuildings + item.affectedMultiStoryBuildings}}</td>
									<td>{{item.affectedPrivateBuildings}}</td>
									<td>{{item.affectedMultiStoryBuildings}}</td>
									<td>{{item.beginTime | formatDateSecond}}</td>
									<td>{{item.startTime | formatDateSecond}}</td>
									<td>{{item.endTime ? item.endTime : '' | formatDateSecond}}</td>
									<td v-if="can('settings_accident', 'Edit')">
										<div class="btn-group">
											<button type="button" class="icon-btn"
													@click="readInfo(item.id)">
												<i class="mdi mdi-pencil"></i>
											</button>
											<button type="button" class="icon-btn"
													@click="deleteInfo(item.id)">
												<i class="mdi mdi-delete text-danger"></i>
											</button>
										</div>
									</td>
								</tr>
								</tbody>
							</table>
							<div class="" style="display: flex; justify-content: center; margin-top: 10px;">
								<paginate
										:page-count="pagesCount"
										v-if="pagesCount > 1"
										:click-handler="paginateData"
										container-class="pagination base_pagination"
										page-class="page-item"
										prev-class="page-item ctrl"
										next-class="page-item ctrl"
										page-link-class="page-link"
										prev-link-class="page-link"
										next-link-class="page-link"
										prev-text="<i class='mdi mdi-chevron-left'></i>"
										next-text="<i class='mdi mdi-chevron-right'></i>"
										:page-range="3"
										:margin-pages="1">
								</paginate>
							</div>
						</div>
					</div>
				</div>
			</div>


			<div class="modal fade" id="addModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
				 aria-hidden="true">
				<div class="modal-dialog fn_ivr_modal" role="document" style="width: 500px;">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title d-flex justify-content-center w-100" id="exampleModalLabel">Add
								info</h5>
						</div>
						<div class="modal-body">
							<div class="form-group">
								<label class="col-form-label">{{$store.state.locale.serviceName}}:</label>
								<select v-model="addItem.organizationId" class="form-control">
									<option v-for="org in orgList" :value="org.id">
										{{org.name}}
									</option>
								</select>
							</div>
							<div class="form-group row">
								<div class="col-6">
									<label class="col-form-label">{{$store.state.locale.district}}:</label>
									<select v-model="addItem.regionId" class="form-control">
										<option v-for="district in districtList" :value="district.id">
											{{district.name}}
										</option>
									</select>
								</div>
								<div class="col-6">
									<label class="col-form-label">{{$store.state.locale.street}}:</label>
									<!--<select v-model="addItem.streetId" class="form-control">-->
									<!--<option v-for="street in streetList" :value="street.id">{{street.name}}-->
									<!--</option>-->
									<!--</select>-->
									<multiselect
											:tabindex="10"
											class="base_multiselect"
											placeholder=""
											v-model="addItem.streetIds"
											:options="streetList"
											:multiple="true"
											:close-on-select="false"
											:searchable="true"
											:clear-on-select="false"
											:show-labels="false"
											:taggable="true"
											@tag="addTag"
											label="name"
											track-by="id"
									>
									</multiselect>
								</div>
							</div>

							<div class="form-group row">
								<div class="col-6">
									<label class="col-form-label">{{$store.state.locale.house}}:</label>
									<select v-model="addItem.houseId" class="form-control">
										<option v-for="house in houseList" :value="house.id">{{house.name}}</option>
									</select>
								</div>
								<div class="col-6">
									<label class="col-form-label">{{$store.state.locale.address}}:</label>
									<input type="text" class="form-control" v-model="addItem.address">
								</div>
							</div>
							<div class="form-group row">
								<div class="col-6">
									<label for="active" class="col-form-label">{{$store.state.locale.criticality}}:</label>
									<select name="" id="active" class="form-control" v-model="addItem.criticality"
											required>
										<option :value="0">{{$store.state.locale.info}}</option>
										<option :value="1">{{$store.state.locale.mediumCritical}}</option>
										<option :value="2">{{$store.state.locale.critical}}</option>
									</select>
								</div>
								<div class="col-6">
									<label for="active" class="col-form-label">{{$store.state.locale.newstype}}:</label>

									<multiselect
											:tabindex="10"
											class="base_multiselect"
											placeholder=""
											v-model="addItem.newsTypeId"
											:options="newsType"
											:close-on-select="true"
											:searchable="true"
											:clear-on-select="false"
											:show-labels="false"
											:taggable="true"
											@tag="addNewsType"
											label="name"
											track-by="id"
									>
									</multiselect>
								</div>
							</div>
							<div class="form-group" v-if="showOther">
								<input type="text" class="form-control" v-model="addItem.newsTypeString">
							</div>
							<div class="form-group row">
								<div class="col-6">
									<label class="col-form-label">{{$store.state.locale.beginDate}}:</label>
									<datepicker
											v-model="addItem.beginTime"
											:config="options">
									</datepicker>
								</div>
								<div class="col-6">
									<label class="col-form-label">{{$store.state.locale.endDate}}:</label>
									<datepicker
											v-model="addItem.endTime"
											:config="options">
									</datepicker>
								</div>
							</div>
							<div class="form-group">
								<label class="col-form-label">{{$store.state.locale.startWork}}:</label>
								<datepicker
										v-model="addItem.startTime"
										:config="options">
								</datepicker>
							</div>
							<div class="form-group row">
								<div class="col-6">
									<label class="col-form-label">{{$store.state.locale.own}}:</label>
									<input type="number" class="form-control" v-model="addItem.affectedPrivateBuildings">
								</div>
								<div class="col-6">
									<label class="col-form-label">{{$store.state.locale.sevFloor}}:</label>
									<input type="number" class="form-control" v-model="addItem.affectedMultiStoryBuildings">
								</div>
							</div>
							<div class="form-group">
								<label class="base_label">{{$store.state.locale.description}}:</label>
								<textarea class="form-control base_input" rows="5"
										  v-model="addItem.description"></textarea>
							</div>
							<button type="submit" v-if="!addItem.id" class="fn_btn btn_fn_success mt-3 w-100 m-0" @click="saveInfo">{{$store.state.locale.save}}</button>
							<button type="submit" v-if="addItem.id" class="fn_btn btn_fn_success mt-3 w-100 m-0" @click="updateInfo">{{$store.state.locale.save}}</button>
						</div>
					</div>
				</div>
			</div>
		</div>
	</section>
</template>

<script>
	import Datepicker from "vue-bootstrap-datetimepicker";
	import Paginate from 'vuejs-paginate';
	import 'pc-bootstrap4-datetimepicker/build/css/bootstrap-datetimepicker.css';

	export default {
		name: "index.vue",
		components: {Datepicker, Paginate},
		data() {
			return {
				isFinished: false,
				fromDate: '',
				toDate: '',

				cityListD: [
					{
						id: 1,
						name: 'Tashkent'
					}
				],
				cityIdD: 0,
				districtIdD: 0,
				streetIdD: 0,
				houseIdD: 0,
				districtListD: [],
				streetListD: [],
				houseListD: [],
				flatListD: [],


				news: [],
				cityId: 0,
				districtId: 0,
				streetId: 0,
				houseId: 0,
				page: 1,
				allCount: null,
				districtList: [],
				streetList: [],
				houseList: [],
				newsType: [],
				orgList: [],
				allStreets: [],
				showOther: false,
				selectedStreet: {},
				addItem: {
					criticality: 0,
					description: "",
					cityId: 0,
					regionId: 0,
					streetIds: [],
					streetId: 0,
					houseId: 0,
					newsTypeId: 0,
					newsTypeString: '',
					beginTime: null,
					endTime: null,
					startTime: null,
					organizationId: this.$store.state.organization_id ? this.$store.state.organization_id : 0,
					address: "",
					affectedPrivateBuildings: 0,
					affectedMultiStoryBuildings: 0,
				},
				options: {
					format: 'YYYY-MM-DD HH:m:s',
					useCurrent: false,
					showClear: true,
					showClose: true,
					locale: 'ru',
					icons: {
						time: 'mdi mdi-clock-outline',
						date: 'mdi mdi-calendar',
						up: 'mdi mdi-arrow-up',
						down: 'mdi mdi-arrow-down',
						previous: 'mdi mdi-arrow-left',
						next: 'mdi mdi-arrow-right',
						today: 'mdi mdi-calendar-today',
						clear: 'mdi mdi-delete-outline',
						close: 'mdi mdi-alpha-x-circle-outline'
					}
				}


			}
		},
		created() {
			this.getAll();

			this.intervalId = setInterval(() => {
				this.getAll();
			}, 10000);
		},
		mounted() {

		},
		destroyed() {
			clearInterval(this.intervalId);
		},
		methods: {
			getAll() {
				this.$http.get('Hokimiyat/District/100000')
					.then(res => {
						if (res.data) {
							this.districtList = res.data.districts;
						}
					});
				this.$http.get('HokimiyatNews/newsTypes').then(res => {
					res.data.newsTypes.map(res => {
						let item = {};
						item['id'] = res.id;
						item['name'] = res.name_ru;
						this.newsType.push(item);
					});
				});
				this.$http.get('Admin/organization').then(res => {
					this.orgList = res.data.data;
				});

				let from, to;
				if (this.fromDate || this.toDate) {
					from = this.fromDate;
					to = this.toDate;
				} else {
					let newDate = moment(new Date()).format('YYYY-MM-DD')
					from = newDate;
					this.fromDate = newDate;
					to = newDate;
					this.toDate = newDate;
				}

				this.$http.get('/HokimiyatNews/newsFiltered' + '?cityId=' + this.cityId + '&regionId=' + this.districtIdD + '&streetId=' + this.streetIdD + '&houseId=' + this.houseIdD + '&page=' + this.page + '&userId=' + this.$store.state.user_id + '&isFinished=' + this.isFinished + '&from=' + from + '&to=' + to).then(res => {
					if (res.data) {
						this.news = res.data.newses;
						this.allCount = res.data.count;
					}
				});
				this.$http.get('/Hokimiyat/Streets').then(res => {
					this.allStreets = res.data.streets;
				})
			},


			getDistrictsD() {
				this.$http.get('Hokimiyat/District/100000')
					.then(res => {
						if (res.data) {
							this.districtListD = res.data.districts
						}
					});
			},
			getStreetsD() {
				this.$http.get('Hokimiyat/Street/' + this.districtIdD)
					.then(res => {
						if (res.data) {
							this.streetListD = res.data.streets
						}
					});
			},
			getHousesD() {
				this.$http.get('Hokimiyat/House/' + this.streetIdD)
					.then(res => {
						if (res.data) {
							this.houseListD = res.data.houses
						}
					});
			},


			getStreets() {
				this.$http.get('Hokimiyat/Street/' + this.addItem.regionId)
					.then(res => {
						if (res.data) {
							this.streetList = res.data.streets;
						}
					});
			},
			getViewStreets(ids) {

				let result = '';
				ids.forEach(id => {
					result += ((this.allStreets.find(item => item.id === parseInt(id)) || {name: ''}).name + ', ');
				});
				return result.slice(0, -2);
			},
			getHouses() {
				this.$http.get('Hokimiyat/House/' + this.addItem.streetIds[0].id)
					.then(res => {
						if (res.data) {
							if (this.addItem.streetIds.length === 1) {
								this.houseList = res.data.houses;
							} else {
								this.houseList = [];
							}
						}
					});
			},
			getFlats() {
				this.$http.get('Hokimiyat/Flat/' + this.addItem.houseId)
					.then(res => {
						if (res.data) {
							this.flatList = res.data.flats;
						}
					});
			},
			saveInfo() {
				this.addItem.id = null;
				let news = {
					cityId: 0,
					regionId: this.addItem.regionId,
					streetIds: this.addItem.streetIds.length > 0 ? this.addItem.streetIds.map(x => x.id.toString()) : [],
					houseId: this.addItem.houseId,
					criticality: this.addItem.criticality,
					description: this.addItem.description,
					newsTypeId: this.addItem.newsTypeId.id ? this.addItem.newsTypeId.id : null,
					newsTypeString: this.addItem.newsTypeId === 1 ? this.addItem.newsTypeString : '',
					beginTime: this.addItem.beginTime == null ? new Date() : this.addItem.beginTime,
					endTime: this.addItem.endTime == null ? null : this.addItem.endTime,
					startTime: this.addItem.startTime == null ? new Date() : this.addItem.startTime,
					organizationId: parseInt(this.addItem.organizationId),
					address: this.addItem.address,
					affectedPrivateBuildings: this.addItem.affectedPrivateBuildings,
					affectedMultiStoryBuildings: this.addItem.affectedMultiStoryBuildings,
				};
				this.$http.post('HokimiyatNews/news', news).then(res => {
					if (res.statusText === "OK") {
						$('#addModal').modal('hide');
						this.addItem.streetIds = [];
						this.getAll();
						this.showOther = false;
					}
				})
			},
			deleteInfo(id) {
				if (confirm('You are about to delete the item(s)!\nAre you sure?')) {
					this.$http.delete('HokimiyatNews/news/' + id).then(res => {
						if (res.statusText === "OK") {
							this.getAll();
						}
					})
				}

			},
			readInfo(id) {
				this.$http.get('HokimiyatNews/news/' + id).then(res => {
					if (res.statusText === "OK") {
						this.addItem = res.data.news;
						let items = [];
						setTimeout(() => {
							this.addItem.streetIds.forEach(id => {
								items.push({
									id: id,
									name: (this.streetList.find(n => n.id === parseInt(id)) || {name: ''}).name
								});
							});
							this.addItem.streetIds = items;
							$('#addModal').modal('show');
						}, 500);
						this.addItem.newsTypeId = {id: res.data.news.newsTypeId, name: this.newsType.find(x => x.id == res.data.news.newsTypeId).name}
					}
				})
			},
			updateInfo() {
				this.addItem.newsTypeString = this.addItem.newsTypeId === 1 ? this.addItem.newsTypeString : '';
				this.addItem.newsTypeId = this.addItem.newsTypeId.id;
				this.addItem.streetIds = this.addItem.streetIds.map(it => it = parseInt(it.id));
				this.$http.patch('HokimiyatNews/news/', this.addItem)
					.then(result => {
						if (result.statusText === "OK") {
							$('#addModal').modal('hide');
							this.getAll();
						} else {
							console.log('sdfsd');
						}
					});
			},
			paginateData(page) {
				this.page = page;
				this.getAll();
				this.animateScrollToTop();
			},
			animateScrollToTop() {
				window.scroll({
					top: 0,
					left: 0,
					behavior: 'smooth'
				});
			},
			addTag(newTag) {
				let add = {
					Name: newTag,
					DistrictId: this.addItem.regionId,
				};
				this.$http.post('Hokimiyat/Street', add).then(res => {
					console.log(res);
					this.addItem.streetIds.push({
						'id': res.data.id,
						'name': newTag
					});
					this.streetList.push({
						'id': res.data.id,
						'name': newTag
					})
				});

			},
			addNewsType(newTag) {
				let add = {
					name_uz: newTag,
					name_en: newTag,
					name_ru: newTag,
					OrganizationId: this.addItem.organizationId,
				};
				this.$http.post('HokimiyatNews/newsType', add).then(res => {
					console.log(res);
					this.newsType.push({
						'id': res.data.id,
						'name': newTag
					});
					this.addItem.newsTypeId = {
						id: res.data.id,
						name: newTag
					};
				});
			},
			resetForm() {
				this.addItem.criticality = 0;
				this.addItem.description = "";
				this.addItem.cityId = 0;
				this.addItem.regionId = 0;
				this.addItem.streetIds = [];
				this.addItem.streetId = 0;
				this.addItem.houseId = 0;
				this.addItem.newsTypeId = 0;
				this.addItem.newsTypeString = '';
				this.addItem.beginTime = null;
				this.addItem.endTime = null;
				this.addItem.startTime = null;
				this.addItem.organizationId = this.$store.state.organization_id ? this.$store.state.organization_id : 0;
				this.addItem.address = "";
				this.addItem.affectedPrivateBuildings = 0;
				this.addItem.affectedMultiStoryBuildings = 0;
				this.addItem.id = null;
			}

		},
		watch: {
			cityIdD: function (val) {
				this.getDistrictsD();
				this.districtId = 0;
			},
			districtIdD: function (val) {
				this.getStreetsD();
				this.streetId = 0;
			},
			streetIdD: function (val) {
				this.getHousesD();
				this.houseId = 0;
			},


			'addItem.regionId': function (val) {
				this.getStreets();
			},
			'addItem.streetIds': function (val) {
				this.getHouses();
			},
			'addItem.houseId': function (val) {
				this.getFlats();
			},

		},
		computed: {
			lang() {
				return this.$store.state.lang
			},
			pagesCount: function () {
				return Math.ceil(this.allCount / 100);
			},
		}
	}
</script>

<style scoped>
	tr th {
		vertical-align: middle;
	}

	.base_multiselect .multiselect__tags {
		height: 37px !important;
	}
</style>